import React, { ComponentType, HTMLProps, Ref } from "react";
import CSSProps from "./_utils/CSSProps";
export declare type Omit<T, K extends keyof T> = Pick<T, ({
    [P in keyof T]: P;
} & {
    [P in K]: never;
})[keyof T]>;
export declare type CSSProperties = {
    [key in keyof typeof CSSProps]?: string | number;
};
export declare type AllProps<T = any> = Omit<HTMLProps<T>, "as"> & ReaKitProps<T> & CSSProperties;
export declare type SingleAsProp = keyof JSX.IntrinsicElements | ComponentType<AllProps>;
export declare type AsProp = SingleAsProp | SingleAsProp[];
export interface ReaKitProps<T = any> {
    as?: AsProp | null;
    nextAs?: SingleAsProp | null;
    elementRef?: Ref<T>;
}
export declare type ReaKitComponent<P extends AllProps = object> = ComponentType<P> & {
    asComponents: AsProp;
    as: (asComponents: AsProp) => ReaKitComponent<P>;
};
declare type AllPropsWithAs<T extends AllProps> = Omit<T, "as"> & AllProps;
declare function as(asComponents: AsProp): <P extends AllProps<any>>(WrappedComponent: React.ComponentType<P>) => ReaKitComponent<AllPropsWithAs<P>>;
export default as;
